QGIS Application - Bug report #20298
Invalid layer not freed when added to the registry
2018-10-31 02:49 PM - Hugo Mercier

Status: Closed

Priority: Normal

Assignee:

Category: Data Provider

Affected QGIS version:2.18.25 Regression?: No
Operating System: Linux and Windows Easy fix?: No

Pull Request or Patch supplied: Resolution: end of life
Crashes QGIS or corrupls data: Copied to github as #: 28119
Description

This simple code

| = QgsVectorLayer("mydb.sqlite|layername=invalid_layer", "I, "ogr")

QgsMapLayerRegistry.instance().addMapLayer(l)

where | points to a valid SQLite file, but an invalid table name will result in | being not valid (l.isValid() == false).

Adding this layer to the registry will keep the connection to the SQLite opened forever. Which may lead to concurrency problems
(especially under Windows).

The problem seems similar with the spatialite provider.

| can't find yet where it comes from (sip bindings ? the connection pool registry ? )

QGIS 3 not affected

History

#1 - 2018-11-01 12:53 PM - Alessandro Pasotti

Hi Hugo, maybe totally unrelated, but just a quick note to make sure you are aware of the ongoing work on QGIS 3 bad layer handling: the basic concept is

that a layer can become invalid at any time and the layer store can contain both valid and invalid layers.

See: hitps://github.com/qgis/QGIS/pull/8359

#2 - 2018-11-05 08:24 AM - Hugo Mercier

Hi Alessandro, thanks for the information about the new behaviour in QGIS 3. But if I'm correct, this is unrelated to the problem here :)

And in order to complete the report, | forgot to mention the problem is that the layer is not freed even after calling
QgsMapLayerRegistry.instance().removeAllMapLayers() and after making sure all local variables are destroyed.

It can be tested by running (under linux) something like 'Isof -c "qgis" | grep "t.sqlite™ and see that the opened sqlite file is still opened.

Maybe it is due to the "/Transfer/" keyword on ggsmaplayeregistry.sip ? in case the passed layer is actually not added to the registry, Python's ref count

still gets a +1 and never getsa -1 ?
https://github.com/qgis/QGIS/pull/8359

#3 - 2018-11-05 02:17 PM - Alessandro Pasotti

If that's the problem, | would suggest you to wait until my https:/github.com/qgis/QGIS/pull/8359 is merged.

"bad" (invalid) layers can now be added to the registry and when removed they would be destroyed as if they were valid layers.

#4 - 2018-11-05 02:24 PM - Alessandro Pasotti

Nevermind, it's 2.18, sorry for the noise

#5 - 2019-01-21 12:35 AM - Jiirgen Fischer
- Status changed from Open to Feedback

Please test with QGIS 3.4 - QGIS 2.18 reached it's end of life.

#6 - 2019-03-09 03:10 PM - Giovanni Manghi
- Resolution set to end of life
- Status changed from Feedback to Closed

End of life notice: QGIS 2.18 LTR

Source:
http://blog.qgis.org/2019/03/09/end-of-life-notice-qgis-2-18-Itr/

QGIS 3.4 has recently become our new Long Term Release (LTR) version. This is a major step in our history - a long term release version based on the
massive updates, library upgrades and improvements that we carried out in the course of the 2.x to 3x upgrade cycle.

We strongly encourage all users who are currently using QGIS 2.18 LTR as their preferred QGIS release to migrate to QGIS 3.4. This new LTR version
will receive regular bugfixes for at least one year. It also includes hundreds of new functions, usability improvements, bugfixes, and other goodies. See the
relevant changelogs for a good sampling of all the new features that have gone into version 3.4

Most plugins have been either migrated or incorporated into the core QGIS code base.

We strongly discourage the continued use of QGIS 2.18 LTR as it is now officially unsupported, which means we’ll not provide any bug fix releases for it.

You should also note that we intend to close all bug tickets referring to the now obsolete LTR version. Original reporters will receive a notification of the
ticket closure and are encouraged to check whether the issue persists in the new LTR, in which case they should reopen the ticket.

If you would like to better understand the QGIS release roadmap, check out our roadmap page! It outlines the schedule for upcoming releases and will help
you plan your deployment of QGIS into an operational environment.

The development of QGIS 3.4 LTR has been made possible by the work of hundreds of volunteers, by the investments of companies, professionals, and

administrations, and by continuous donations and financial support from many of you. We sincerely thank you all and encourage you to collaborate and
support the project even more, for the long term improvement and sustainability of the QGIS project.
